#!/bin/bash
#
# Tunein radio player 3.4 by lead farmer https://www.antixforum.com/forums/topic/tunein-radio-how-to-make-a-terminal-radio-player/
# 28.10.2023 edited by RJP for Finnish people

folder=channels
favorite_entry=8

category_entries() {
	# You can change this section!
	# Make sure the text files corresponding to the category
	# 3 rock = 3.txt
	echo -e "Tunein Radio\n	
1 Suomalaiset
2 Lisää tähän genre
3 Rock
4 Lisää tähän genre
5 Lisää tähän genre
6 Lisää tähän genre
7 Lisää tähän genre
$favorite_entry Favorites"
	#Favorites must be the last one!
	# set favorite_entry abouve to the right value that fit the order
}


favorite_select() {
	if [[ "$recored_delete_save" == "s" ]]; then
	  favorite=$station
	fi
	favorite_name=$(cat $folder/$category.txt | head -$favorite | tail +$favorite | awk '{print $2}')
	favorite_check=$(cat $folder/$favorite_entry.txt | grep "$favorite_name" | wc -l)
	echo -e "\nAdd $favorite_name to Favorites? [Y]\n"
	read favorite_y
	if [[ $favorite_check -gt 0 ]]; then
	  echo -e "\n$favorite_name is already in Favorites\n"
	elif [[ "$favorite_y" == "Y" || "$favorite_y" == "y" ]]; then
	  number_favorites=$(cat $folder/$favorite_entry.txt | wc -l)
      number_favorites_p1=$(($number_favorites+1))
      favorite_name_url=$(cat $folder/$category.txt | head -$favorite | tail +$favorite | awk '{print $2" "$3}')
      echo "$number_favorites_p1 $favorite_name_url" >> $favorite_entry.txt
      echo -e "\n$favorite_name saved in Favorites\n"
    else
      echo -e "\nStation didn't saved\n"
    fi
    read -p "Press any key to continue... " -n1 -s
}
delete_station() {	
	if [[ "$recored_delete_save" == "d" ]]; then
	  delete_name=$(cat $folder/$category.txt | head -$station | tail +$station | awk '{print $2}')
	  echo -e "\nAre you sure you want to delete $delete_name station? [Y]\n"
	  read delete_y
	  if [[ "$delete_y" == "Y" || "$delete_y" == "y" ]]; then
	    sed -i "${station}d" $folder/$category.txt
	    delete_station2
	  else
        echo -e "Station didn't delete\n"
	    read -p "Press any key to continue... " -n1 -s	
	  fi
	elif [[ "$station" == "d" ]]; then
	  delete_name=$(cat $folder/$category.txt | head -$favorite | tail +$favorite | awk '{print $2}')
	  echo -e "\nAre you sure you want to delete $delete_name station? [Y]\n"
	  read delete_y
	  if [[ "$delete_y" == "Y" || "$delete_y" == "y" ]]; then
	    sed -i "${favorite}d" $folder/$category.txt
	    delete_station2
	  else
        echo -e "Station didn't delete\n"
	    read -p "Press any key to continue... " -n1 -s	    
	  fi
	fi

}

delete_station2() {
	echo -e "\nPlease wait..." &
    cp $folder/$category.txt $folder/tmp.txt
    rm $folder/$category.txt
    number_stations_m1=$(cat $folder/tmp.txt | wc -l)
    for ((i = 1 ; i <= $number_stations_m1 ; i++)); do
      new_name_url=$(cat $folder/tmp.txt | head -$i | tail +$i | awk '{print $2" "$3}')
      echo "$i $new_name_url" >> $folder/$category.txt
    done
    rm $folder/tmp.txt
    echo -e "\nStation deleted\n"
	read -p "Press any key to continue... " -n1 -s
}

tunein_help() {
	clear
	echo -e "Tunein Radio Help\n\n
	0 - Play a random station\n
	q - Back\n
	r - Add r in the begnning of the station number to recored 
		exsample: recording station 10 -> r10
	    Recordings saved in the recording folder
	    Recording is an experimental feature, and might not work\n
	s - Save station in Favorites
	    1) Add s in the beginning of the number station -> s10
	    2) s alone will save the previous listened station\n
	d - Delete station
	    1) Add d in the beginning of the number station -> d10
	    2) d alone will delete the previous listened station\n\n
\nhttps://www.antixforum.com/forums/topic/tunein-radio-how-to-make-a-terminal-radio-player/\n"
	read -p "Press any key to continue... " -n1 -s
}


[ ! -d "$folder/recording" ] && mkdir "$folder/recording"

while true; do
  clear
  category_entries
  echo -e "\nSelect category number, q to exit, --help"
  read category
  [[ "$category" == "--help" ]] && tunein_help
  [[ "$category" == "q" ]] && break
  favorite="null"
  if [[ $category -gt 0 &&  $category -le $favorite_entry ]]; then
    while true; do
      clear
      favorite_set=0
      cat $folder/$category.txt | awk '{print $1" "$2}'
      echo -e "\nSelect station number, 0 random station, q go back, --help\n"
      read station
      [[ "$station" == "--help" ]] && tunein_help
      number_stations=$(cat $folder/$category.txt | wc -l)
      recored_delete_save=$(echo "$station" | grep -Po '[rds](?=\d+)')      
      if [[ "$recored_delete_save" == "r" || "$recored_delete_save" == "d" || "$recored_delete_save" == "s" ]]; then
        station=$(echo "$station" | grep -Po '\d+')
      fi
      station_digit=$(echo "$station" | grep -Po '\d+' | wc -l)
      if [[ $station -ge 0 && $station -le $number_stations && $station_digit -eq 1 ]] || [[ "$station" == "s" || "$station" == "q" || "$station" == "d" ]]; then
        if [[ "$recored_delete_save" == "d" ]] || [[ "$favorite" != "null" && "$station" == "d" ]]; then
          delete_station
        fi 
        [[ "$station" == "q" ]] && break
        if [[ "$station" == "0" ]]; then
          station=$(echo $((1 + $RANDOM % $number_stations)))
        fi
        if [[ "$station" == "s" && "$favorite" != "null" && $favorite_entry -ne $category ]] || [[ "$recored_delete_save" == "s" ]]; then
          favorite_select
          favorite_set=1
        fi
        favorite=$station
        if [[ $favorite_set -eq 0 && "$recored_delete_save" != "d" && "$station" != "d" && "$station" != "s" && "$recored_delete_save" != "s" ]]; then
          station_url=$(cat $folder/$category.txt | head -$station | tail +$station | awk '{print $3}')
          station_name=$(cat $folder/$category.txt | head -$station | tail +$station | awk '{print $2}')
          clear
          if [[ "$recored_delete_save" == "r" ]]; then
            echo -e "Recording $station_name station, q to go back\n\n"
            recording_date=$(date +"%F-%T")
            mpv $station_url --stream-record=$folder/recording/$recording_date-$station_name.mp3
          else
            echo -e "Playing $station_name station, q to go back\n\n"
            mpv $station_url
          fi
        else
          favorite="null"
        fi
      fi
    done
  fi
done

exit 0
